"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pipe_1 = require("@reactive-js/pipe");
const observable_1 = require("@reactive-js/observable");
class AsyncEnumeratorImpl extends observable_1.AbstractDelegatingSubscriber {
    constructor(delegate, observable) {
        super(delegate);
        this.observable = observable;
        this.isSynchronous = false;
        this.add(observable);
    }
    get subscriberCount() {
        return this.observable.subscriberCount;
    }
    notify(req) {
        this.delegate.notify(req);
    }
    dispatch(req) {
        this.delegate.dispatch(req);
    }
    enumerate() {
        return this.observable.enumerate();
    }
    subscribe(subscriber) {
        this.observable.subscribe(subscriber);
    }
}
exports.AsyncEnumeratorImpl = AsyncEnumeratorImpl;
exports.createAsyncEnumerator = (operator, scheduler, replayCount = 0) => {
    const subject = observable_1.createSubject(scheduler);
    const safeSubscriber = observable_1.toSafeSubscriber(subject);
    const observable = pipe_1.pipe(subject, operator, observable_1.publish(scheduler, replayCount));
    return new AsyncEnumeratorImpl(safeSubscriber, observable);
};
//# sourceMappingURL=createAsyncEnumerator.js.map