"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pipe_1 = require("@reactive-js/pipe");
const observable_1 = require("@reactive-js/observable");
const createAsyncEnumerator_1 = require("./createAsyncEnumerator");
const doneError = Symbol("IteratorDone");
const fromIterableAsyncEnumerator = (iterable, scheduler, replayCount) => {
    const iterator = iterable[Symbol.iterator]();
    const enumerator = observable_1.fromIterator(iterator).enumerate();
    const operator = (obs) => pipe_1.pipe(obs, observable_1.map(_ => {
        if (enumerator.move()) {
            return enumerator.current;
        }
        else {
            throw doneError;
        }
    }), observable_1.catchError(error => (error === doneError ? observable_1.empty() : undefined)));
    return createAsyncEnumerator_1.createAsyncEnumerator(operator, scheduler, replayCount);
};
class FromIterableAsyncEnumerable {
    constructor(iterable) {
        this.iterable = iterable;
    }
    enumerateAsync(scheduler, replayCount) {
        return fromIterableAsyncEnumerator(this.iterable, scheduler, replayCount);
    }
}
exports.fromIterable = (iterable) => new FromIterableAsyncEnumerable(iterable);
//# sourceMappingURL=fromIterable.js.map