"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pipe_1 = require("@reactive-js/pipe");
const observable_1 = require("@reactive-js/observable");
const createAsyncEnumerator_1 = require("./createAsyncEnumerator");
const generateScanner = (generator) => (acc, _) => generator(acc);
class GenerateAsyncEnumerable {
    constructor(generator, initialValue) {
        this.generator = generator;
        this.initialValue = initialValue;
    }
    enumerateAsync(scheduler, replayCount) {
        const operator = (obs) => pipe_1.pipe(obs, observable_1.scan(generateScanner(this.generator), this.initialValue));
        return createAsyncEnumerator_1.createAsyncEnumerator(operator, scheduler, replayCount);
    }
}
exports.generate = (generator, initialValue) => new GenerateAsyncEnumerable(generator, initialValue);
//# sourceMappingURL=generate.js.map