"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const observable_1 = require("@reactive-js/observable");
const pipe_1 = require("@reactive-js/pipe");
const identity_1 = require("./identity");
const lift_1 = require("./lift");
const map_1 = require("./map");
class ReduceObservable {
    constructor(enumerable, withLatestSelector, initial) {
        this.enumerable = enumerable;
        this.withLatestSelector = withLatestSelector;
        this.initial = initial;
        this.enumerate = observable_1.observableMixin.enumerate;
        this.isSynchronous = false;
    }
    subscribe(subscriber) {
        const enumerator = this.enumerable.enumerateAsync(subscriber);
        const eventEmitter = pipe_1.pipe(identity_1.identity(), lift_1.lift(observable_1.onNotify(continueRequest => {
            enumerator.dispatch(continueRequest.req);
        })), map_1.map(({ acc }) => acc)).enumerateAsync(subscriber);
        subscriber.add(enumerator).add(eventEmitter);
        pipe_1.pipe(observable_1.merge(observable_1.ofValue(this.initial()), pipe_1.pipe(enumerator, observable_1.withLatestFrom(eventEmitter, this.withLatestSelector))), observable_1.onNotify(next => {
            if (next.type === 1) {
                eventEmitter.dispatch(next);
            }
            else {
                enumerator.dispose();
            }
        }), observable_1.map(({ acc }) => acc), observable_1.takeLast()).subscribe(subscriber);
    }
}
exports.reduce = (reducer, initial) => enumerable => {
    const withLatestSelector = (next, acc) => reducer(acc, next);
    return new ReduceObservable(enumerable, withLatestSelector, initial);
};
//# sourceMappingURL=reduce.js.map