"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pipe_1 = require("@reactive-js/pipe");
const observable_1 = require("@reactive-js/observable");
const createAsyncEnumerator_1 = require("./createAsyncEnumerator");
class DelegatingStateStoreAsyncEnumerable {
    constructor(enumerable, initialState, equals) {
        this.enumerable = enumerable;
        this.initialState = initialState;
        this.equals = equals;
    }
    enumerateAsync(scheduler, replayCount) {
        const enumerator = this.enumerable.enumerateAsync(scheduler);
        const operator = (obs) => {
            const onIteratorNextChangedObs = pipe_1.pipe(enumerator, observable_1.onNotify(v => retval.dispatch(_ => v)), observable_1.ignoreElements());
            const stateObs = pipe_1.pipe(obs, observable_1.scan((acc, next) => next(acc), this.initialState), observable_1.distinctUntilChanged(this.equals), observable_1.onNotify((next) => enumerator.dispatch(next)));
            return observable_1.merge(onIteratorNextChangedObs, stateObs);
        };
        const retval = createAsyncEnumerator_1.createAsyncEnumerator(operator, scheduler, replayCount).add(enumerator);
        return retval;
    }
}
exports.toStateStore = (initialState, equals) => iterable => new DelegatingStateStoreAsyncEnumerable(iterable, initialState, equals);
//# sourceMappingURL=toStateStore.js.map