import { pipe } from "@reactive-js/pipe";
import { concatAll, fromArray as fromArrayObs, map, scan, takeFirst, } from "@reactive-js/observable";
import { createAsyncEnumerator } from "./createAsyncEnumerator";
const fromArrayScanner = (acc, _) => acc + 1;
class FromArrayAsyncEnumerable {
    constructor(values) {
        this.values = values;
    }
    enumerateAsync(scheduler, replayCount) {
        const values = this.values;
        const operator = (obs) => pipe(obs, scan(fromArrayScanner, () => -1), map(startIndex => pipe(fromArrayObs(values, { startIndex }), takeFirst())), concatAll(), takeFirst(values.length));
        return createAsyncEnumerator(operator, scheduler, replayCount);
    }
}
export const fromArray = (values) => new FromArrayAsyncEnumerable(values);
//# sourceMappingURL=fromArray.js.map