import { pipe } from "@reactive-js/pipe";
import { scan } from "@reactive-js/observable";
import { createAsyncEnumerator } from "./createAsyncEnumerator";
const generateScanner = (generator) => (acc, _) => generator(acc);
class GenerateAsyncEnumerable {
    constructor(generator, initialValue) {
        this.generator = generator;
        this.initialValue = initialValue;
    }
    enumerateAsync(scheduler, replayCount) {
        const operator = (obs) => pipe(obs, scan(generateScanner(this.generator), this.initialValue));
        return createAsyncEnumerator(operator, scheduler, replayCount);
    }
}
export const generate = (generator, initialValue) => new GenerateAsyncEnumerable(generator, initialValue);
//# sourceMappingURL=generate.js.map