import { AsyncEnumerableLike } from "./interfaces";
import { ObservableLike } from "@reactive-js/observable";
import { OperatorLike } from "@reactive-js/pipe";
export declare const enum ReducerRequestType {
    Continue = 1,
    Done = 2
}
export interface ContinueRequestLike<TReq, TAcc> {
    readonly type: ReducerRequestType.Continue;
    readonly req: TReq;
    readonly acc: TAcc;
}
export interface DoneRequestLike<TAcc> {
    readonly type: ReducerRequestType.Done;
    readonly acc: TAcc;
}
export declare type ReducerRequest<TReq, TAcc> = ContinueRequestLike<TReq, TAcc> | DoneRequestLike<TAcc>;
export declare const reduce: <TReq, TSrc, TAcc>(reducer: (acc: TAcc, next: TSrc) => ReducerRequest<TReq, TAcc>, initial: () => ReducerRequest<TReq, TAcc>) => OperatorLike<AsyncEnumerableLike<TReq, TSrc>, ObservableLike<TAcc>>;
