import { pipe } from "@reactive-js/pipe";
import { distinctUntilChanged, ignoreElements, merge, onNotify, scan, } from "@reactive-js/observable";
import { createAsyncEnumerator } from "./createAsyncEnumerator";
class DelegatingStateStoreAsyncEnumerable {
    constructor(enumerable, initialState, equals) {
        this.enumerable = enumerable;
        this.initialState = initialState;
        this.equals = equals;
    }
    enumerateAsync(scheduler, replayCount) {
        const enumerator = this.enumerable.enumerateAsync(scheduler);
        const operator = (obs) => {
            const onIteratorNextChangedObs = pipe(enumerator, onNotify(v => retval.dispatch(_ => v)), ignoreElements());
            const stateObs = pipe(obs, scan((acc, next) => next(acc), this.initialState), distinctUntilChanged(this.equals), onNotify((next) => enumerator.dispatch(next)));
            return merge(onIteratorNextChangedObs, stateObs);
        };
        const retval = createAsyncEnumerator(operator, scheduler, replayCount).add(enumerator);
        return retval;
    }
}
export const toStateStore = (initialState, equals) => iterable => new DelegatingStateStoreAsyncEnumerable(iterable, initialState, equals);
//# sourceMappingURL=toStateStore.js.map