import { AbstractDelegatingSubscriber, MulticastObservableLike, SubscriberLike, ObservableOperatorLike, SafeSubscriberLike } from "@reactive-js/observable";
import { SchedulerLike } from "@reactive-js/scheduler";
import { AsyncEnumeratorLike } from "./interfaces";
import { EnumeratorLike } from "@reactive-js/enumerable";
export declare class AsyncEnumeratorImpl<TReq, T> extends AbstractDelegatingSubscriber<TReq, TReq> implements AsyncEnumeratorLike<TReq, T> {
    private readonly observable;
    readonly isSynchronous = false;
    constructor(delegate: SafeSubscriberLike<TReq>, observable: MulticastObservableLike<T>);
    get subscriberCount(): number;
    notify(req: TReq): void;
    dispatch(req: TReq): void;
    enumerate(): EnumeratorLike<void, T>;
    subscribe(subscriber: SubscriberLike<T>): void;
}
export declare const createAsyncEnumerator: <TReq, T>(operator: ObservableOperatorLike<TReq, T>, scheduler: SchedulerLike, replayCount?: number) => AsyncEnumeratorLike<TReq, T>;
//# sourceMappingURL=createAsyncEnumerator.d.ts.map